    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------------
    028     * BoxAndWhiskerXYToolTipGenerator.java
    029     * ------------------------------------
    030     * (C) Copyright 2003-2007, by David Browning and Contributors.
    031     *
    032     * Original Author:  David Browning;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: BoxAndWhiskerXYToolTipGenerator.java,v 1.4.2.2 2007/02/02 15:52:42 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 05-Aug-2003 : Version 1, contributed by David Browning (DG);
    040     * 13-Aug-2003 : Implemented Cloneable (DG);
    041     * 28-Aug-2003 : Updated for changes in dataset API (DG);
    042     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    043     * 27-Feb-2004 : Renamed BoxAndWhiskerItemLabelGenerator -->
    044     *               BoxAndWhiskerXYItemLabelGenerator, and modified to use
    045     *               MessageFormat (DG);
    046     * 15-Jul-2004 : Switched getX() with getXValue() and getY() with
    047     *               getYValue() (DG);
    048     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    049     *
    050     */
    051
    052    package org.jfree.chart.labels;
    053
    054    import java.io.Serializable;
    055    import java.text.DateFormat;
    056    import java.text.MessageFormat;
    057    import java.text.NumberFormat;
    058    import java.util.Date;
    059
    060    import org.jfree.data.statistics.BoxAndWhiskerXYDataset;
    061    import org.jfree.data.xy.XYDataset;
    062
    063    /**
    064     * An item label generator for plots that use data from a
    065     * {@link BoxAndWhiskerXYDataset}.
    066     * <P>
    067     * The tooltip text and item label text are composed using a
    068     * {@link java.text.MessageFormat} object, that can aggregate some or all of
    069     * the following string values into a message.
    070     * <table>
    071     * <tr><td>0</td><td>Series Name</td></tr>
    072     * <tr><td>1</td><td>X (value or date)</td></tr>
    073     * <tr><td>2</td><td>Mean</td></tr>
    074     * <tr><td>3</td><td>Median</td></tr>
    075     * <tr><td>4</td><td>Minimum</td></tr>
    076     * <tr><td>5</td><td>Maximum</td></tr>
    077     * <tr><td>6</td><td>Quartile 1</td></tr>
    078     * <tr><td>7</td><td>Quartile 3</td></tr>
    079     * </table>
    080     */
    081    public class BoxAndWhiskerXYToolTipGenerator extends StandardXYToolTipGenerator
    082                                                 implements XYToolTipGenerator,
    083                                                            Cloneable,
    084                                                            Serializable {
    085
    086        /** For serialization. */
    087        private static final long serialVersionUID = -2648775791161459710L;
    088
    089        /** The default tooltip format string. */
    090        public static final String DEFAULT_TOOL_TIP_FORMAT
    091            = "X: {1} Mean: {2} Median: {3} Min: {4} Max: {5} Q1: {6} Q3: {7} ";
    092
    093        /**
    094         * Creates a default item label generator.
    095         */
    096        public BoxAndWhiskerXYToolTipGenerator() {
    097            super(
    098                DEFAULT_TOOL_TIP_FORMAT,
    099                NumberFormat.getInstance(), NumberFormat.getInstance()
    100            );
    101        }
    102
    103        /**
    104         * Creates a new item label generator.  If the date formatter is not
    105         * <code>null</code>, the x-values will be formatted as dates.
    106         *
    107         * @param toolTipFormat  the tool tip format string (<code>null</code> not
    108         *                       permitted).
    109         * @param numberFormat  the number formatter (<code>null</code> not
    110         *                      permitted).
    111         * @param dateFormat  the date formatter (<code>null</code> permitted).
    112         */
    113        public BoxAndWhiskerXYToolTipGenerator(String toolTipFormat,
    114                                               DateFormat dateFormat,
    115                                               NumberFormat numberFormat) {
    116
    117            super(toolTipFormat, dateFormat, numberFormat);
    118
    119        }
    120
    121        /**
    122         * Creates the array of items that can be passed to the
    123         * {@link MessageFormat} class for creating labels.
    124         *
    125         * @param dataset  the dataset (<code>null</code> not permitted).
    126         * @param series  the series (zero-based index).
    127         * @param item  the item (zero-based index).
    128         *
    129         * @return The items (never <code>null</code>).
    130         */
    131        protected Object[] createItemArray(XYDataset dataset, int series,
    132                                           int item) {
    133            Object[] result = new Object[8];
    134            result[0] = dataset.getSeriesKey(series).toString();
    135            Number x = dataset.getX(series, item);
    136            if (getXDateFormat() != null) {
    137                result[1] = getXDateFormat().format(new Date(x.longValue()));
    138            }
    139            else {
    140                result[1] = getXFormat().format(x);
    141            }
    142            NumberFormat formatter = getYFormat();
    143
    144            if (dataset instanceof BoxAndWhiskerXYDataset) {
    145                BoxAndWhiskerXYDataset d = (BoxAndWhiskerXYDataset) dataset;
    146                result[2] = formatter.format(d.getMeanValue(series, item));
    147                result[3] = formatter.format(d.getMedianValue(series, item));
    148                result[4] = formatter.format(d.getMinRegularValue(series, item));
    149                result[5] = formatter.format(d.getMaxRegularValue(series, item));
    150                result[6] = formatter.format(d.getQ1Value(series, item));
    151                result[7] = formatter.format(d.getQ3Value(series, item));
    152            }
    153            return result;
    154        }
    155
    156        /**
    157         * Tests if this object is equal to another.
    158         *
    159         * @param obj  the other object.
    160         *
    161         * @return A boolean.
    162         */
    163        public boolean equals(Object obj) {
    164            if (obj == this) {
    165                return true;
    166            }
    167            if (!(obj instanceof BoxAndWhiskerXYToolTipGenerator)) {
    168                return false;
    169            }
    170            return super.equals(obj);
    171        }
    172
    173    }